# frozen_string_literal: true

require 'i18n'
require 'graphql'
require 'cht-lib-fabric/error_codes'

module RoleManagement
  module ErrorCodes
    include ::Platform::ErrorCodes

    NOT_FOUND = "not_found"
    INVALID_PERMISSION = "invalid_permission"
    BINDING_ALREADY_EXISTS = "binding_already_exists"
    INVALID_ROLE_DOCUMENT = "invalid_role_document"
    MISSING_ROLE_DOCUMENT_NAME = "missing_role_document_name"
    INVALID_ORGANIZATION = "invalid_organization"
    INVALID_USER_GROUP = "invalid_user_group"
    INVALID_CRN = "invalid_crn"
  end

  module Exceptions
    class NotFound < ::StandardError; end
    class InvalidPermission < ::StandardError; end
    class BindingAlreadyExists < ::StandardError; end
    class InvalidRoleDocument < ::StandardError; end
    class MissingRoleDocumentName < ::StandardError; end
    class InvalidOrganization < ::StandardError; end
    class InvalidUserGroup < ::StandardError; end
  end
end
