# frozen_string_literal: true

require 'graphql'
require 'active_support/dependencies/autoload'

require 'cht-lib-fabric/crn'
require 'cht-lib-fabric/helpers/graphql'
require 'cht-lib-fabric/helpers/graphql/raise_error'

module RoleManagement
  module GraphQL
    module Types
      extend ActiveSupport::Autoload

      autoload :Query
      autoload :Mutation

      autoload :ContentMetadata
      autoload :ContentMetadataInput
      autoload :CreateUserGroupRoleBindingInput
      autoload :DeleteUserGroupRoleBindingInput
      autoload :Permission
      autoload :PermissionGroup
      autoload :PermissionInput
      autoload :RoleDocument
      autoload :SharedContentMetadata
      autoload :SharedMetadataInput
      autoload :SharedRoleDocument
      autoload :SharedRoleDocumentOrganization
      autoload :SharedRoleDocumentUserGroup
      autoload :SharedUserGroupRoleBinding
      autoload :UpdateUserGroupRoleBindingInput
      autoload :UpdateUserGroupRoleBindingsInput
      autoload :UpdateUserGroupRoleBindingsPayload
      autoload :UserGroup
      autoload :UserGroupRoleBinding
      autoload :UserGroupRoleBindingOrganizationInput
      autoload :UserGroupRoleBindingRoleDocumentInput
      autoload :UserGroupRoleBindingUserGroupInput

    end
  end
end