# frozen_string_literal: true

require 'graphql'

module RoleManagement
  module GraphQL
    module Types
      module Mutations
        class DeleteRoleDocument < ::GraphQL::Schema::RelayClassicMutation

          description "Deletes a role document"

          argument :id, ID, required: true

          field :id, ID, null: false

          def resolve(id:)

            result = RoleManagement::Actions::DeleteRoleDocument.new.call(id, context)

            { id: result }
          end

        end
      end
    end
  end
end
