# frozen_string_literal: true

require 'graphql'

module RoleManagement
  module GraphQL
    module Types
      module Mutations
        class UpdateUserGroupRoleBindings < ::GraphQL::Schema::Mutation

          description "Create/Update/Deletes a user group role bindings"

          argument :input, UpdateUserGroupRoleBindingsInput, required: false

          field :creates, [UserGroupRoleBinding], null: true
          field :updates, [UserGroupRoleBinding], null: true
          field :deletes, [ID], null: true

          def resolve(input:)
            result = RoleManagement::Actions::UpdateUserGroupRoleBindings.new.call(input,
                                                                          context)

            {
                creates: result['creates'],
                updates: result['updates'],
                deletes: result['deletes'],
            }
          end

        end
      end
    end
  end
end
