# frozen_string_literal: true

require 'cht-lib-fabric/graphql/federation/types'

module RoleManagement
  module GraphQL
    module Types
      class PermissionGroup < ::Platform::GraphQL::Types::BaseObject
        field :group_name, String, "Represents permission group name", null: true
        field :is_root, Boolean, "Represents if permission is at root level of PermissionGroups", null: false
        field :child_ids, [String], null: true
        field :permissions, [Permission], "Represents the actions available", null: true
        field :permission_group, [PermissionGroup], null: true
        field :id, String, "Id of the permission group", null: true

        def group_name
          obj_h = object.to_h.with_indifferent_access
          obj_h['groupName']
        end

        def is_root
          obj_h = object.to_h.with_indifferent_access
          obj_h['isRoot']
        end

        def child_ids
          obj_h = object.to_h.with_indifferent_access
          obj_h['childIds']
        end

        def permission_group
          obj_h = object.to_h.with_indifferent_access
          obj_h['permissionGroup']
        end

      end
    end
  end
end