# frozen_string_literal: true

require 'cht-lib-fabric/graphql/federation/types'

module RoleManagement
  module GraphQL
    module Types
      class SharedRoleDocument < ::Platform::GraphQL::Types::BaseObject

        field :role_document, RoleDocument, null: false
        field :user_group_bindings, [SharedUserGroupRoleBinding], null: false

        def role_document
          object.roleDocument
        end

        def user_group_bindings
          obj_h = object.to_h.with_indifferent_access
          obj_h['userGroupBindings']
        end
      end
    end
  end
end
