# frozen_string_literal: true

require 'cht-lib-fabric/graphql/federation/types'

module RoleManagement
  module GraphQL
    module Types
      class UserGroupRoleBinding < ::Platform::GraphQL::Types::BaseObject
        implements ::GraphQL::Relay::Node.interface

        field :id, ID, null: false

        field :role_document, RoleDocument, null: false

        field :user_group_id, ID, null: false
        field :organization_id, ID, null: false
        field :organization_ids, [ID], null: false

        field :created_at, ::GraphQL::Types::ISO8601DateTime, null: false
        field :updated_at, ::GraphQL::Types::ISO8601DateTime, null: false

        field :created_by_id, ID, null: false
        field :updated_by_id, ID, null: false

      end
    end
  end
end
