# frozen_string_literal: true

require 'role_management/graphql/schema'
require 'role_management/graphql/include_fields'

# See: ENG-20240 - Warm Type Definition Cache
# See: ENG-24912 - Duplicate Type Definition / Warm Type Cache
def warm_cache_workaround
    begin
      if ENV['RACK_ENV'] == 'production' ||
         ENV['RACK_ENV'] == 'development' ||
         ENV['RACK_ENV'] == 'staging'
         Application["logger"].info "Warming schema type definitions in #{ENV['RACK_ENV']}"
        # For the schema to traverse and load all its definitions
        RoleManagement::GraphQL::Schema.graphql_definition
      else
        Application["logger"].warn "Not warming schema type definitions in #{ENV['RACK_ENV']}"
      end
    rescue => ex
        Application["logger"].error ex
    end
end

warm_cache_workaround
