 module RoleManagement
  module GraphQL
    module IncludeFields
      def selection_path(node, path = {})
        path[node.name] = node.scoped_children.values.each_with_object({}) do |x, memo|
          x.keys.each{|k| memo[k] = selection_path(x[k], memo)}
        end
      end

      def include_permissions?(ctx)
        return false if invalid_selection?(ctx)
        (selection_path(ctx.selection).dig('edges', 'node', 'permissions') != nil) ||
        (selection_path(ctx.selection).dig('permissions') != nil)
      end

      def include_permission_labels?(ctx)
        return false if invalid_selection?(ctx)
        (selection_path(ctx.selection).dig('edges', 'node', 'permissions','label') != nil) ||
        (selection_path(ctx.selection).dig('permissions','label') != nil) ||
        (selection_path(ctx.selection).dig('permissions','edges','node','label') != nil)
      end

      def include_role_bindings?(ctx)
        return false if invalid_selection?(ctx)
        (selection_path(ctx.selection).dig('edges', 'node', 'userGroupRoleBindings') != nil) ||
        (selection_path(ctx.selection).dig('userGroupRoleBindings') != nil)
      end

      def invalid_selection?(ctx)
        return true if ctx.is_a?(Hash) && ctx[:selection].nil?
        return true if ctx.is_a?(::GraphQL::Query::Context) && !ctx.respond_to?(:selection)
        return true if ctx.selection.nil?
        return false
      end
    end
  end
end
