# frozen_string_literal: true

require 'import'

module RoleManagement
  module Helpers
    class OrgManagementHelper
      include Import['logger',
                     'clients.org_management']

      #
      # Returns an organization with the given id
      #
      def get_organization(context_request, id)
        org = org_management.get_organization(request: context_request[:request], id:id)
        if org.nil?
          logger.debug "No Organization with id : [#{id}]"
          nil
        else
          logger.debug "Organization Found: [#{id}]"
          org
        end
      end

    end
  end
end