# frozen_string_literal: true
# auto_register: false

require 'karafka'
require 'role_management/consumers/organizations'
require 'role_management/consumers/user_groups'

::Karafka::App.consumer_groups.draw do
  consumer_group :role_management do
    topic 'com.cloudhealthtech.svc.organizations.change' do
      consumer ::RoleManagement::Consumers::Organizations
    end
    topic 'com.cloudhealthtech.svc.user_management.usergroups.change' do
      consumer ::RoleManagement::Consumers::UserGroups
    end
  end
end
