# frozen_string_literal: true

require 'cht-lib-fabric/crn'

module RoleManagement
  module Models
    module CRNs
      class RoleDocument < ::Platform::CRN

        # @return [String] the name of the service for a role document.
        attribute :service,
                  ::Platform::DryTypes.Value('role-document')
                                      .default('role-document')

        def role_document_id
          self.details.to_i
        end
      end
    end
  end
end
