# frozen_string_literal: true

require 'cht-lib-fabric/crn'

module RoleManagement
  module Models
    module CRNs
      class UserGroupRoleBinding < ::Platform::CRN

        # @return [String] the name of the service for a role document.
        attribute :service,
                  ::Platform::DryTypes.Value('role-mgmt')
                                      .default('role-mgmt')

        attribute :details,
                  ::Platform::DryTypes::Strict::String.constrained(
                    format: /^ugrb:\d+$/
                  )

        def self.new(options)
          if options[:role_binding_id]
            options[:details] = ["ugrb",options.delete(:role_binding_id)].join(':')
          end
          super(options)
        end

        def user_group_role_binding_id
          details.split(':')[1].to_i
        end
      end
    end
  end
end
