# frozen_string_literal: true

require 'cht-lib-fabric/dry_types'
require 'dry-struct'

module RoleManagement
  module Models
    class PermissionGroup < ::Dry::Struct
      attribute :groupName, ::Platform::DryTypes::Strict::String

      attribute :permissionGroup, ::Platform::DryTypes::Strict::Array.of(PermissionGroup)
                                                                      .optional
      attribute :permissions, ::Platform::DryTypes::Strict::Array.of(Permission)
                                                                 .optional

      attribute :id, ::Platform::DryTypes::Strict::String.optional.default(nil)

      attribute :childIds, ::Platform::DryTypes::Strict::Array.of(::Platform::DryTypes::Strict::String)
                               .optional.default(nil)

      attribute :isRoot, ::Platform::DryTypes::Strict::Bool.default(false)
    end
  end
end
