# frozen_string_literal: true

require 'cht-lib-fabric/dry_types'
require 'dry-struct'

module RoleManagement
  module Models
    class SharedRoleDocumentUserGroup < ::Dry::Struct
      attribute :id, ::Platform::DryTypes::Strict::String
      attribute :name, ::Platform::DryTypes::Strict::String
    end

    class SharedRoleDocumentOrganization < ::Dry::Struct
      attribute :id, ::Platform::DryTypes::Strict::String
      attribute :name, ::Platform::DryTypes::Strict::String
    end

    class SharedUserGroupRoleBinding < ::Dry::Struct
      attribute :organization, ::RoleManagement::Models::SharedRoleDocumentOrganization
      attribute :organizations, ::Platform::DryTypes::Strict::Array.of(SharedRoleDocumentOrganization)
      attribute :userGroup, ::RoleManagement::Models::SharedRoleDocumentUserGroup
    end

    class SharedRoleDocument < ::Dry::Struct
    attribute :roleDocument, ::RoleManagement::Models::RoleDocument
    attribute :userGroupBindings, ::Platform::DryTypes::Strict::Array.of(SharedUserGroupRoleBinding)
    end
  end
end