# frozen_string_literal: true

require 'cht-lib-fabric/dry_types'
require 'dry-struct'

module RoleManagement
  module Models
    class UserGroupRoleBinding < ::RoleManagement::Models::Relay::Node
      # @return [Platform::CRNs::RoleDocument]
      attribute :id, ::Platform::DryTypes::Strict::String

      attribute :role_document, ::RoleManagement::Models::RoleDocument.optional.default(nil)
      attribute :user_group_id, ::Platform::DryTypes::Strict::String
      attribute :organization_id, ::Platform::DryTypes::Strict::String
      attribute :customer_id, ::Platform::DryTypes::Strict::String
      attribute :organization_ids, ::Platform::DryTypes::Strict::Array.of(::Platform::DryTypes::Strict::String)

      # @return user CRNs
      attribute :created_by_id, ::Platform::DryTypes::Strict::String
      attribute :updated_by_id, ::Platform::DryTypes::Strict::String

      attribute :created_at, ::Platform::DryTypes::Strict::Time
      attribute :updated_at, ::Platform::DryTypes::Strict::Time

      alias_method :roleDocument, :role_document
      alias_method :userGroupId, :user_group_id
      alias_method :organizationIds, :organization_ids
      alias_method :organizationId, :organization_id
      alias_method :createdById, :created_by_id
      alias_method :updatedById, :updated_by_id
      alias_method :createdAt, :created_at
      alias_method :updatedAt, :updated_at
    end
  end
end
