# frozen_string_literal: true
require 'role_management/messages/role_document'
require 'role_management/messages/role_binding'
require 'import'

module RoleManagement
  module Utils
    class EventFactory
      include Import['logger']
      # 
      # Returns a message object for a specific RMS type
      #
      # @param  - object -  The object representing the message    
      # @return          -  The RMS Message object for the type
      def get_event(object)
        logger.debug "Constructing event for #{object} #{object.class.name}"
        if object.is_a?(RoleManagement::Models::RoleDocument)
          ::RoleManagement::Messages::RoleDocument.new
        elsif object.is_a?(RoleManagement::Models::UserGroupRoleBinding)
          ::RoleManagement::Messages::RoleBinding.new
        else
          nil
        end
      end  
    end 
  end
end
